// -*-Mode: C++;-*- 
#ifndef CThreadView_included
#define CThreadView_included

#include "ListViewData.h"
#include "qtimer.h"
#include "helpers/smart_pointer.h"

class CMySql;

class CThreadView : public CListViewData
{
    Q_OBJECT

public:

    CThreadView(smart_pointer<CMySql>& _sql_server,QWidget* parent = NULL,const char* name = NULL);
    virtual ~CThreadView();

protected slots:
    void RefreshList();
    void KillThread();
    void newTimeout(int aValue);
    void NewFixedFont();

protected:
    smart_pointer<CMySql> sql_server;
    QTimer*ResetTimer;
    int m_Timeout;

public slots:
    void hide();
    void show();
};
#endif // CThreadView_included
